#ifndef MAKEDEPEND
#include <stdlib.h>
#include <stdarg.h>
#endif
#include "music.h"

static musicdriver *drivers = NULL;

musicdriver *finddriver(int optchar)
{
	musicdriver *tmp;
	for(tmp=drivers; tmp; tmp=tmp->next)
		if(tmp->optchar == optchar)
			break;
	return tmp;
}

void registerdrivers(musicdriver *p, ...)
{
	va_list ap;
	va_start(ap, p);
	
	while(p)
	{
		if(finddriver(p->optchar) == NULL)
		{
			p->next = drivers;
			drivers = p;
		}		
		p = va_arg(ap, musicdriver *);
	}
	va_end(ap);
}

void foreachdriver(void (*rut)(const musicdriver *, void *), void *a)
{
	musicdriver *tmp;
	if(!rut)return;
	for(tmp=drivers; tmp; tmp=tmp->next)rut(tmp, a);
}
